/////////////////////////////////////////////////////////////////////////////////
// (c) vanhoa 2007                           Last edit:         3/20/2007 11:52AM
/////////////////////////////////////////////////////////////////////////////////

extern "C" {
#include "stdlib.h"
#include "stdio.h"
#include "string.h"
#include "math.h"
#include <float.h>
}//[end extern "C"]

#define maxsize 256		//[The max size of text that you can input]

class CharArray
{
	private:
		unsigned char *lst;
		unsigned int size;
	public:
		CharArray(){size=0;lst=new unsigned char[1];lst[0]=0;};
		~CharArray(){delete [] lst;};
		//####################################################//
		bool Insert(char value,unsigned int pos)
		{
			if(pos>size) return 0;
			if(size>maxsize) return 0;
			size++;
			unsigned char *lst2=new unsigned char[size+1];
			if(!lst2) return 0;
			for(int i=0;i<pos;i++) lst2[i]=lst[i];
			lst2[pos]=value;
			for(int i=pos;i<size-1;i++) lst2[i+1]=lst[i];
			delete [] lst;
			lst=lst2;
			lst[size]=0;
			return 1;
		}//[end function "Insert"]
		//####################################################//
		bool Remove(unsigned int pos)
		{
			if(pos>size||(int)pos<0) return 0;
			size--;if(size<1) size=1;
			unsigned char *lst2=new unsigned char[size+1];
			if(!lst2) return 0;
			for(int i=0;i<pos;i++) lst2[i]=lst[i];
			for(int i=pos;i<size;i++) lst2[i]=lst[i+1];
			delete [] lst;
			lst=lst2;
			lst[size]=0;
			return 1;
		}//[end function "Insert"]
		//####################################################//
		bool Add(char value){return Insert(value,size);};
		//####################################################//
		int Insert(char *y,int po)
		{
			unsigned char *s=new unsigned char[strlen(y)];
			int pos=po;
			strcpy((char*)s,y);
			for(int i=0;i<strlen((char*)s);i++)
				if(!Insert(s[i],pos++)) return 0;
			return pos-po;
		}//[end function "Insert"]
		//####################################################//
		void OverWrite(char value,unsigned int pos)
		{
			if(pos==size-1) {Insert(value,pos);return;}
			if(pos>size-1) return;
			lst[pos]=value;
		}//[end function "OverWrite"]
		//####################################################//
		unsigned char *AsString()
		{
			lst[size]=0;
			return lst;
		}//[end function "AsString"]
		//####################################################//
		void DataSet(unsigned char *tx)
		{
			//strcpy((char*)lst,(char*)tx);
			//size=strlen((char*)tx);
			int i=0;
			while(tx[i])
			{
				Add(tx[i]);i++;
			}//[end while]
			tx[i]=0;
		}//[end function "DataSet"]
		//####################################################//
		int Len()
		{
			return size+1;
		}//[end function "Len"]
		//####################################################//
		unsigned char GetAt(int i)
		{
			if(i<0||i>=size) return 0;
			return lst[i];
		}//[end function "GetAt"]
		unsigned char *glst()
		{
			return lst;
		}//[end function "glst"]
};//[end class "CharArray"]
//####################################################//
#define MIN(x,y) (((x)>(y))? y:x)//MIN of 2 number macro
//####################################################//
class LineEdit
{
	private:
		CharArray *txt;
		int curpos;
		int displeft;
		int maxdisplen;
		int Top;
		int Left;
	public:
		//####################################################//
		LineEdit(int dl=1,int mdl=21,int tp=1,int lf=1)
		{
			txt=new CharArray();
			displeft=dl-1;maxdisplen=mdl;Top=tp;Left=lf;
			curpos=0;
		}//[end function "LineEdit"]
		CharArray *GetTxT(){return txt;}
		//####################################################//
		~LineEdit()
		{
			txt->~CharArray();
			delete txt;
		}//[end function "~LineEdit"]
		//####################################################//
		unsigned char *Text()
		{
			return txt->AsString();
		}//[end function "Text"]
		//####################################################//
		int Len()
		{
			return txt->Len();
		}//[end function "Len"]
		//####################################################//
		void DataSet(unsigned char *tx)
		{
			txt->DataSet(tx);
		}//[end function "DataSet"]
		//####################################################//
		void Draw(bool dispcur=1)
		{
			unsigned char s[]="\0\0";
			for(int i=displeft;i<displeft+maxdisplen;i++)
			{
				s[0]=txt->GetAt(i);if(!s[0]) s[0]=' ';locate(i-displeft+Left,Top);Print(s);
			};
			s[0]=' ';locate(maxdisplen+Left,Top);Print(s);
			Bdisp_ClearLineVRAM((maxdisplen+Left-1)*6,(Top-1)*8,(maxdisplen+Left-1)*6,(Top-1)*8+7);
			if(dispcur) Bdisp_DrawLineVRAM((curpos-displeft+Left-1)*6,(Top-1)*8,(curpos-displeft+Left-1)*6,(Top-1)*8+7);
		}//[end function "Draw"]
		//####################################################//
		bool Input()
		{
			unsigned int key;
			int dc=1,dt=0;
			unsigned char curra='a';
			while(1)
			{
				if(curpos>=displeft+maxdisplen) displeft=curpos-maxdisplen+1;
				if(curpos<displeft) displeft=curpos;
				if(curpos==displeft) displeft=curpos-2;
				if(displeft<0) displeft=0;
				Draw(dc);
				GetKey(&key);
				dt=curpos;
				//////////////////////////////////////////////////////////////
				if(key==KEY_CTRL_LEFT) if(curpos>0) curpos--;
				if(key==KEY_CTRL_RIGHT) if(txt->GetAt(curpos)!='\0') curpos++;
				if(key==KEY_CTRL_UP) curpos=0;
				if(key==KEY_CTRL_DOWN) while(txt->GetAt(curpos)!='\0') curpos++;
				//////////////////////////////////////////////////////////////
				if(key==KEY_CTRL_DEL) if(curpos==0) txt->Remove(0); else if(curpos>0) curpos-=txt->Remove(curpos-1);
				//////////////////////////////////////////////////////////////
				if(key==KEY_CTRL_F4) curra=((curra=='a')?'A':'a');
				//////////////////////////////////////////////////////////////
				if(key>=KEY_CHAR_A&&key<=KEY_CHAR_Z) if(txt->Insert(curra+key-KEY_CHAR_A,curpos)) curpos++;
				if(key>=KEY_CHAR_0&&key<=KEY_CHAR_9) if(txt->Insert('0'+key-KEY_CHAR_0,curpos)) curpos++;
				if(dt==curpos)
				switch(key){
					case KEY_CHAR_DP: if(txt->Insert('.',curpos)) curpos++;break;
					case KEY_CHAR_PLUS: if(txt->Insert('+',curpos)) curpos++;break;
					case KEY_CHAR_MINUS: if(txt->Insert('-',curpos)) curpos++;break;
					case KEY_CHAR_MULT: if(txt->Insert('*',curpos)) curpos++;break;
					case KEY_CHAR_DIV: if(txt->Insert('/',curpos)) curpos++;break;
					case KEY_CHAR_LPAR: if(txt->Insert('(',curpos)) curpos++;break;
					case KEY_CHAR_RPAR: if(txt->Insert(')',curpos)) curpos++;break;
					case KEY_CHAR_COMMA: if(txt->Insert(',',curpos)) curpos++;break;
					case KEY_CHAR_LOG: curpos+=txt->Insert("Log(",curpos);break;
					case KEY_CHAR_LN:  curpos+=txt->Insert("Ln(" ,curpos);break;
					case KEY_CHAR_SIN: curpos+=txt->Insert("Sin(",curpos);break;
					case KEY_CHAR_COS: curpos+=txt->Insert("Cos(",curpos);break;
					case KEY_CHAR_TAN: curpos+=txt->Insert("Tan(",curpos); break;
					case KEY_CHAR_ASIN: curpos+=txt->Insert("Asin(",curpos);break;
					case KEY_CHAR_ACOS: curpos+=txt->Insert("Acos(",curpos);break;
					case KEY_CHAR_ATAN: curpos+=txt->Insert("Atan(",curpos); break;
					case KEY_CHAR_SQUARE: curpos+=txt->Insert("^2",curpos); break;
					case KEY_CHAR_ROOT: curpos+=txt->Insert("Sqr(",curpos); break;
					case KEY_CHAR_POW: curpos+=txt->Insert("^(",curpos); break;
					case KEY_CHAR_POWROOT: curpos+=txt->Insert("^(1/(",curpos); break;
					case KEY_CHAR_EXPN10: curpos+=txt->Insert("*10^(",curpos); break;
					case KEY_CHAR_EXPN: curpos+=txt->Insert("*e(",curpos); break;
					case KEY_CHAR_CUBEROOT: curpos+=txt->Insert("^(1/3)",curpos); break;
					case KEY_CHAR_RECIP: curpos+=txt->Insert("^(-1)",curpos); break;
				}//[end switch and if]
			if(key==KEY_CTRL_EXE)  return 1;
			if(key==KEY_CTRL_EXIT) return 0;
			}//[end while]
		}//[end function "Input"]
};



//#############################################################################################################
//How to use?
//This is an example:
////this will make a line edit which display the text from 1st char, disp 18 chars (3;4) is the pos
//LineEdit* le=new LineEdit(1,18,3,4);
////Set the data (if you dont do this, its data will be "" )
//le->DataSet("abcabc+123123");
///function LineEdit::Input() return true is you press [EXE] and false if you press [EXIT]
//if(le->Input())
//	{
//		//Do something
//		//you can call LineEdit::Text() to return the current text
//	}
//#############################################################################################################