/////////////////////////////////////////////////////////////////////////////////
// (c) vanhoa 2007                                   Last edit:  3/13/2007 6:33PM
/////////////////////////////////////////////////////////////////////////////////

extern "C" {
#include "stdlib.h"
#include "stdio.h"
#include "string.h"
#include "math.h"
#include <float.h>
}

#define maxsize 256
class CharArray
{
	private:
		unsigned char *lst;
		unsigned int size;
	public:
		CharArray(){size=0;lst=new unsigned char[1];lst[0]=0;};
		~CharArray(){delete [] lst;};
		//####################################################//
		bool Insert(char value,unsigned int pos)
		{
			if(pos>size) return 0;
			if(size>maxsize) return 0;
			size++;
			unsigned char *lst2=new unsigned char[size+1];
			if(!lst2) return 0;
			for(int i=0;i<pos;i++) lst2[i]=lst[i];
			lst2[pos]=value;
			for(int i=pos;i<size-1;i++) lst2[i+1]=lst[i];
			delete [] lst;
			lst=lst2;
			lst[size]=0;
			return 1;
		}
		//####################################################//
		bool Remove(unsigned int pos)
		{
			if(pos>size||(int)pos<0) return 0;
			size--;if(size<1) size=1;
			unsigned char *lst2=new unsigned char[size+1];
			if(!lst2) return 0;
			for(int i=0;i<pos;i++) lst2[i]=lst[i];
			for(int i=pos;i<size;i++) lst2[i]=lst[i+1];
			delete [] lst;
			lst=lst2;
			lst[size]=0;
			return 1;
		}
		//####################################################//
		bool Add(char value){return Insert(value,size);};
		//####################################################//
		int Insert(char *y,int po)
		{
			unsigned char *s=new unsigned char[strlen(y)];
			int pos=po;
			strcpy((char*)s,y);
			for(int i=0;i<strlen((char*)s);i++)
				if(!Insert(s[i],pos++)) return 0;
			return pos-po;
		}
		//####################################################//
		void OverWrite(char value,unsigned int pos)
		{
			if(pos==size-1) {Insert(value,pos);return;}
			if(pos>size-1) return;
			lst[pos]=value;
		}
		//####################################################//
		unsigned char *AsString()
		{
			lst[size]=0;
			return lst;
		}
		//####################################################//
		void DataSet(unsigned char *tx)
		{
			//strcpy((char*)lst,(char*)tx);
			//size=strlen((char*)tx);
			int i=0;
			while(tx[i])
			{
				Add(tx[i]);i++;
			}
			tx[i]=0;
		}
		//####################################################//
		int Len()
		{
			return size+1;
		}
		//####################################################//
		unsigned char GetAt(int i)
		{
			if(i<0||i>=size) return 0;
			return lst[i];
		}
		unsigned char *glst()
		{
			return lst;
		}
};
//####################################################//
#define MIN(x,y) (((x)>(y))? y:x)
//####################################################//
class LineEdit
{
	private:
		CharArray *txt;
		int curpos;
		int displeft;
		int maxdisplen;
		int Top;
		int Left;
	public:
		//####################################################//
		LineEdit(int dl=1,int mdl=21,int tp=1,int lf=1)
		{
			txt=new CharArray();
			displeft=dl-1;maxdisplen=mdl;Top=tp;Left=lf;
			curpos=0;
		}
		CharArray *GetTxT(){return txt;}
		//####################################################//
		~LineEdit()
		{
			txt->~CharArray();
			delete txt;
		}
		//####################################################//
		unsigned char *Text()
		{
			return txt->AsString();
		}
		//####################################################//
		int Len()
		{
			return txt->Len();
		}
		//####################################################//
		void DataSet(unsigned char *tx)
		{
			txt->DataSet(tx);
		}
		//####################################################//
		void Draw(bool dispcur=1)
		{
			unsigned char s[]="\0\0";
			for(int i=displeft;i<displeft+maxdisplen;i++)
			{
				s[0]=txt->GetAt(i);if(!s[0]) s[0]=' ';locate(i-displeft+Left,Top);Print(s);
			};
			s[0]=' ';locate(maxdisplen+Left,Top);Print(s);
			Bdisp_ClearLineVRAM((maxdisplen+Left-1)*6,(Top-1)*8,(maxdisplen+Left-1)*6,(Top-1)*8+7);
			if(dispcur) Bdisp_DrawLineVRAM((curpos-displeft+Left-1)*6,(Top-1)*8,(curpos-displeft+Left-1)*6,(Top-1)*8+7);
		}
		//####################################################//
		bool Input()
		{
			unsigned int key;
			int dc=1,dt=0;
			unsigned char curra='a';
			while(1)
			{
				if(curpos>=displeft+maxdisplen) displeft=curpos-maxdisplen+1;
				if(curpos<displeft) displeft=curpos;
				if(curpos==displeft) displeft=curpos-2;
				if(displeft<0) displeft=0;
				Draw(dc);
				GetKey(&key);
				dt=curpos;
				//////////////////////////////////////////////////////////////
				if(key==KEY_CTRL_LEFT) if(curpos>0) curpos--;
				if(key==KEY_CTRL_RIGHT) if(txt->GetAt(curpos)!='\0') curpos++;
				if(key==KEY_CTRL_UP) curpos=0;
				if(key==KEY_CTRL_DOWN) while(txt->GetAt(curpos)!='\0') curpos++;
				//////////////////////////////////////////////////////////////
				if(key==KEY_CTRL_DEL) if(curpos==0) txt->Remove(0); else if(curpos>0) curpos-=txt->Remove(curpos-1);
				//////////////////////////////////////////////////////////////
				if(key==KEY_CTRL_F4) curra=((curra=='a')?'A':'a');
				//////////////////////////////////////////////////////////////
				if(key>=KEY_CHAR_A&&key<=KEY_CHAR_Z) if(txt->Insert(curra+key-KEY_CHAR_A,curpos)) curpos++;
				if(key>=KEY_CHAR_0&&key<=KEY_CHAR_9) if(txt->Insert('0'+key-KEY_CHAR_0,curpos)) curpos++;
				if(dt==curpos)
				switch(key){
					case KEY_CHAR_DP: if(txt->Insert('.',curpos)) curpos++;break;
					case KEY_CHAR_PLUS: if(txt->Insert('+',curpos)) curpos++;break;
					case KEY_CHAR_MINUS: if(txt->Insert('-',curpos)) curpos++;break;
					case KEY_CHAR_MULT: if(txt->Insert('*',curpos)) curpos++;break;
					case KEY_CHAR_DIV: if(txt->Insert('/',curpos)) curpos++;break;
					case KEY_CHAR_LPAR: if(txt->Insert('(',curpos)) curpos++;break;
					case KEY_CHAR_RPAR: if(txt->Insert(')',curpos)) curpos++;break;
					case KEY_CHAR_COMMA: if(txt->Insert(',',curpos)) curpos++;break;
					case KEY_CHAR_LOG: curpos+=txt->Insert("Log(",curpos);break;
					case KEY_CHAR_LN:  curpos+=txt->Insert("Ln(" ,curpos);break;
					case KEY_CHAR_SIN: curpos+=txt->Insert("Sin(",curpos);break;
					case KEY_CHAR_COS: curpos+=txt->Insert("Cos(",curpos);break;
					case KEY_CHAR_TAN: curpos+=txt->Insert("Tan(",curpos); break;
					case KEY_CHAR_ASIN: curpos+=txt->Insert("Asin(",curpos);break;
					case KEY_CHAR_ACOS: curpos+=txt->Insert("Acos(",curpos);break;
					case KEY_CHAR_ATAN: curpos+=txt->Insert("Atan(",curpos); break;
					case KEY_CHAR_SQUARE: curpos+=txt->Insert("^2",curpos); break;
					case KEY_CHAR_ROOT: curpos+=txt->Insert("Sqr(",curpos); break;
					case KEY_CHAR_POW: curpos+=txt->Insert("^(",curpos); break;
					case KEY_CHAR_POWROOT: curpos+=txt->Insert("^(1/(",curpos); break;
					case KEY_CHAR_EXPN10: curpos+=txt->Insert("*10^(",curpos); break;
					case KEY_CHAR_EXPN: curpos+=txt->Insert("*e(",curpos); break;
					case KEY_CHAR_CUBEROOT: curpos+=txt->Insert("^(1/3)",curpos); break;
					case KEY_CHAR_RECIP: curpos+=txt->Insert("^(-1)",curpos); break;
				}
			if(key==KEY_CTRL_EXE)  return 1;
			if(key==KEY_CTRL_EXIT) return 0;
			}
		}
};









class G3D
{
	private:
		unsigned char * functions[6];
		unsigned char SelLineStart,selline;
		char functionsel;
		double xmin,xmax,ymin,ymax,zmin,zmax,xscale,yscale,ph,th,smin,smax,spitch,tmin,tmax,tpitch;
		short 	sin_table_th_,sin_table_ph_,
						cos_table_th_,cos_table_ph_;
		short winx1,winy1,winx2,winy2;
		short coord[31][31][3];
		//short fixedcorrd[9]
		bool candraw[31][31];
		//####################################################//
		unsigned char drawtype;
		// 0 : z=f(x,y);
		// 1 : f(t)   (x=f(t);y=g(t);z=h(t));
		// 2 : f(s,t) (x=f(s,t);y=g(s,t);z=h(s,t));
		// 3 : z=f(r,o)
		// 4 : r=f(s,t)
		//####################################################//
	//	char sin_t[360],cos_t[360];
	public:
		//####################################################//
		G3D()
		{
			for(int i=0;i<6;i++)
			{
				functions[i]=new unsigned char[256];
				strcpy((char*)functions[i],"");
			}
			functionsel=-1;
			SelLineStart=0;
			selline=0;
			for(int i=0;i<360;i++)
			{
			//	sin_t[i]=(short)(((float)sin((float)i*1.*atan(1)/45.))*128.);
				//cos_t[i]=(short)(((float)cos((float)i*1.*atan(1)/45.))*128.);
			}
			ymin=zmin=-3;ymax=zmax=3;yscale=.3;
			xmin=-3;xmax=3;xscale=.3;
			winx1=-256;winy1=-128;winx2=256;winy2=128;
			ph=th=2*atan(1)/3;drawtype=0;
			tmin=smin=-4.*atan(1.);tmax=smax=-tmin;tpitch=spitch=20;
		}
		//####################################################//
		void DrawFuncWin()
		{
			unsigned char s[22];
			switch(drawtype)
			{
				case 0:PrintXY(0,0,"Graph Func  :Z=f(x,y) ",1);break;
				case 1:PrintXY(0,0,"Graph Param1:f(t)     ",1);break;
				case 2:PrintXY(0,0,"Graph Param2:f(s,t)   ",1);break;
				case 3:PrintXY(0,0,"Graph Cyl.  :z=f(s,t) ",1);break;
				case 4:PrintXY(0,0,"Graph Spher.:r=f(s,t) ",1);break;
			}
			PrintXY(0,56,"   (c) vanhoa 2007    ",1);
			for(int i=0;i<6;i++)
			{
				s[0]='Z';s[1]='0'+i-SelLineStart+1;s[2]=((i-SelLineStart)==functionsel)?'=':':';s[3]=0;
				PrintXY(0,8*i+8,s,(i-SelLineStart)==selline);
				for(int i2=0;i2<22;i2++) s[i2]=' ';s[21]=0;
				for(int i2=0;i2<MIN(17,strlen((char*)functions[i-SelLineStart]));i2++) s[i2]=functions[i-SelLineStart][i2];
				PrintXY(17,8*i+8,s,(i-SelLineStart)==selline);
			}
		}
		//####################################################//
		void DoIt()
		{
			unsigned int key;
			while(1)
			{
				DrawFuncWin();
				GetKey(&key);
				if(key==KEY_CTRL_F5) {drawtype++;drawtype%=5;}
				if(key==KEY_CTRL_UP)  selline+=5;
				if(key==KEY_CTRL_DOWN) selline++;
				if(key==KEY_CTRL_EXE && functionsel==selline)
				{
						DrawGraph();
				}
				if(key==KEY_CTRL_EXE && functions[selline][0]!='\0')
				{
						functionsel=selline;
				}
				if(key==KEY_CTRL_RIGHT)
				{
					LineEdit* le=new LineEdit(1,18,selline-SelLineStart+2,4);
					le->DataSet(functions[selline]);
					if(le->Input())
					{
//						strcpy(functions[selline],le->GetTxT()->glst());
						le->GetTxT()->AsString();
						for(int iii=0;iii<le->Len();iii++) functions[selline][iii]=le->GetTxT()->GetAt(iii);
					}
					if(functions[selline][0]==0) functionsel=-1;
				}
				if(key==KEY_CTRL_F3)
					if(!ViewWinDow())
						{
							PopUpWin(1);
							locate(4,4);Print("Invail  values!");
							{unsigned int zxccz;GetKey(&zxccz);}
						}
				selline%=6;
			}
		}

		#define vx(x) (127*(x-winx1)/(winx2-winx1))
		#define vy(y) (63*(y-winy1)/(winy2-winy1))
		
		#define xc(x,y,z) ((-sin_table_th_*x+cos_table_th_*y)>>7)
		#define yc(x,y,z) ((-(-cos_table_ph_*cos_table_th_*x-cos_table_ph_*sin_table_th_*y+((sin_table_ph_*z)<<7)))>>14)
		#define _xmin (-256)
		#define _ymin (-256)
		#define _zmin (-256)
		#define _xmax 256
		#define _ymax 256
		#define _zmax 256
		
		void DrawLine(short x,short y,short z,short xx,short yy,short zz){
		if ((y < _ymin&&yy < _ymin)||(y > _ymax&&yy > _ymax)||(x < _xmin&&xx < _xmin)||(xx > _xmax&&x > _xmax) ||(z>_zmax&&zz>_zmax)||(z<_zmin&&zz<_zmin)) return;
		if (x > _xmax)
		{
			z = zz + (_xmax - xx) * (z - zz) / (x - xx);
			y = yy + (_xmax - xx) * (y - yy) / (x - xx);
			x = _xmax;
		}
		if(x < _xmin)
		{
			z = zz - (xx - _xmin) * (z - zz) / (x - xx);
			y = yy - (xx - _xmin) * (y - yy) / (x - xx);
			x = _xmin;
		}
		if(y > _ymax)
		{
			z = zz + (_ymax - yy) * (z - zz) / (y - yy);
			x = xx + (_ymax - yy) * (x - xx) / (y - yy);
			y = _ymax;
		}
		if(y < _ymin)
		{
			z = zz - (yy - _ymin) * (z - zz) / (y - yy);
			x = xx - (yy - _ymin) * (x - xx) / (y - yy);
			y = _ymin;
		}
		if(z > _zmax)
		{
			y = yy + (_zmax - zz) * (y - yy) / (z - zz);
			x = xx + (_zmax - zz) * (x - xx) / (z - zz);
			z = _zmax;
		}
		if(z < _zmin)
		{
			y = yy - (zz - _zmin) * (y - yy) / (z - zz);
			x = xx - (zz - _zmin) * (x - xx) / (z - zz);
			z = _zmin;
		}
		if(xx > _xmax)
		{
			zz = z + (_xmax - x) * (z - zz) / (x - xx);
			yy = y + (_xmax - x) * (y - yy) / (x - xx);
			xx = _xmax;
		}
		if(xx < _xmin)
		{
			zz = z - (x - _xmin) * (z - zz) / (x - xx);
			yy = y - (x - _xmin) * (y - yy) / (x - xx);
			xx = _xmin;
		}
		if(yy > _ymax)
		{
			zz = z + (_ymax - y) * (z - zz) / (y - yy);
			xx = x + (_ymax - y) * (x - xx) / (y - yy);
			yy = _ymax;
		}
		if(yy < _ymin)
		{
			zz = z - (y - _ymin) * (z - zz) / (y - yy);
			xx = x - (y - _ymin) * (x - xx) / (y - yy);
			yy = _ymin;
		}
		if(zz > _zmax)
		{
			yy = y + (_zmax - z) * (y - yy) / (z - zz);
			xx = x + (_zmax - z) * (x - xx) / (z - zz);
			zz = _zmax;
		}
		if(zz < _zmin)
		{
			yy = y - (z - _zmin) * (y - yy) / (z - zz);
			xx = x - (z - _zmin) * (x - xx) / (z - zz);
			zz = _zmin;
		}			
//Bdisp_SetPoint_VRAM(vx(xc(x,y,z)),vy(yc(x,y,z)),1);
//Bdisp_SetPoint_VRAM(vx(xc(xx,yy,zz)),vy(yc(xx,yy,zz)),1);
		Bdisp_DrawLineVRAM(vx(xc(x,y,z)),vy(yc(x,y,z)),vx(xc(xx,yy,zz)),vy(yc(xx,yy,zz)));
		}
		double ct(double a,double b)
		{
			while(a>0) a-=b;
			while(a<0) a+=b;
			return a;
		}
		bool ViewWinDow()
		{
			//LineEdit* le=new LineEdit(1,18,selline-SelLineStart+2,4);
			char opts[16][11]={"Xmin  :%e"," max  :%e"," grid :%e","Ymin  :%e"," max  :%e"," grid :%e","Zmin  :%e"," max  :%e","Angle\xe6\x57:%e","Angle\xe5\x55:%e","smin  :%e"," max  :%e"," pitch :%e","tmin  :%e"," max  :%e"," pitch :%e"};
			double *cn[16]={&xmin,&xmax,&xscale,&ymin,&ymax,&yscale,&zmin,&zmax,&th,&ph,&smin,&smax,&spitch,&tmin,&tmax,&tpitch};
			double cm[16];for(int i=0;i<16;i++) cm[i]=*cn[i];
			cm[2]=(cm[1]-cm[0])/cm[2];
			cm[5]=(cm[4]-cm[3])/cm[5];
			char currsel=0,dsx=0;
			unsigned int k;
			while(1)
			{
				//Draw
				locate(1,1);Print("View Window           ");
				for(int i=0;i<6;i++)
				{
					char s[30];
					sprintf(s,opts[dsx+i],cm[dsx+i]);
					locate(1,2+i);
					if((dsx+i)==currsel) PrintRLine((unsigned char*)s,21); else PrintLine((unsigned char*)s,21);
				}
				//Keys
				GetKey(&k);
				switch(k)
				{
					case KEY_CTRL_UP: currsel+=15;currsel%=16;if(currsel<dsx) dsx=currsel; else if(currsel>dsx+5) dsx=currsel-5; break;
					case KEY_CTRL_DOWN: currsel++;currsel%=16;if(currsel<dsx) dsx=currsel; else if(currsel>dsx+5) dsx=currsel-5;break;
					case KEY_CTRL_LEFT:
					case KEY_CTRL_RIGHT:
					{
						LineEdit* le=new LineEdit(1,14,currsel-dsx+2,8);char s[30];
						sprintf(s,"%f",cm[currsel]);
						le->DataSet((unsigned char*)s);
						if(le->Input())
						{
							double result;
							int epos,ecode=!EvaluateD((char*)le->GetTxT()->AsString(),&result,&epos);
							if(ecode) 
								cm[currsel]=result;
						}
						break;
					}
					case KEY_CTRL_F1:
					cm[3]=cm[6]=-3;
					cm[4]=cm[7]=3;
					cm[0]=-6;cm[1]=6;
					cm[2]=20;cm[5]=20;
					cm[8]=cm[9]=atan(1.)/4;
						break;
					case KEY_CTRL_EXIT://return 0;
					case KEY_CTRL_EXE:
					if(cm[0]>=cm[1]) return 0;
					if(cm[3]>=cm[4]) return 0;
					if(cm[6]>=cm[7]) return 0;
					if(cm[2]<=0||cm[5]<=0) return 0;
					if(cm[2]>30) return 0;
					if(cm[5]>30) return 0;
					if(cm[12]>30) return 0;
					if(cm[15]>30) return 0;
					for(int i=0;i<16;i++) *cn[i]=cm[i];
					*cn[2]=(cm[1]-cm[0])/cm[2];
					*cn[5]=(cm[4]-cm[3])/cm[5];
					return 1;
				}
			}
		}
		void DrawGraph()
		{
			double result;Bkey_Set_RepeatTime(6,2);char axs=0;
			//Init The Table:
			int numx=(xmax-xmin)/xscale+1,numy=(ymax-ymin)/yscale+1;
			short _xscale=(_xmax-_xmin)/(numx-1),_yscale=(_ymax-_ymin)/(numy-1);
			double sscale=(smax-smin)/(spitch-1),tscale=(tmax-tmin)/(tpitch-1);
			PrintMini(1,1,(unsigned char*)"Working... 0%",0);Bdisp_PutDisp_DD();
		// 0 : z=f(x,y);
		// 1 : f(t)   (x=f(t);y=g(t);z=h(t));
		// 2 : f(s,t) (x=f(s,t);y=g(s,t);z=h(s,t));
		// 3 : z=f(r,o)
		// 4 : r=f(s,t)
		switch(drawtype)
		{
			case 0:
			{
			for(int x=0;x<numx;x++)
				for(int y=0;y<numy;y++)
				{//EEVPSPASHJKA
						if(IsKeyDown(KEY_CTRL_AC)) return;
					double d1,d2;d1=xmin+x*xscale,d2=ymin+y*yscale;
					unsigned char s[400];
					sprintf((char*)s,"(0*((X=(x=%f))+(Y=(y=%f))))+%s\0",d1,d2,functions[functionsel]);
					int epos,ecode=!EvaluateD((char*)s,&result,&epos);
					candraw[x][y]=ecode;
					result=(_zmin+(result-zmin)*(_zmax-_zmin)/(zmax-zmin));
					coord[x][y][0]=_xscale*x+_xmin;
					coord[x][y][1]=_yscale*y+_ymin;
					if(ecode) 
						coord[x][y][2]=result;
					sprintf((char*)s,"Working... %d%%\0",(int)(100*((x)*numy+y)/(numx*numy)));PrintMini(1,1,s,0);Bdisp_PutDisp_DD();
				};
				break;
			}//Case 0
			case 1:
			{
				numx=1;numy=tpitch;
			for(int x=0;x<numx;x++)
				for(int y=0;y<numy;y++)
				{//EEVPSPASHJKA
						if(IsKeyDown(KEY_CTRL_AC)) return;
					double d1;d1=tmin+y*tscale;
					unsigned char s[400];
					sprintf((char*)s,"(0*(T=(t=%f)))+EEVPSPASHJKA(%s)\0",d1,functions[functionsel]);
					int epos,ecode=!EvaluateD((char*)s,&result,&epos);
					candraw[x][y]=ecode;
					if(ecode){
						coord[x][y][0]=(_xmin+(save_1-xmin)*(_xmax-_xmin)/(xmax-xmin));
						coord[x][y][1]=(_ymin+(save_2-ymin)*(_ymax-_ymin)/(ymax-ymin));
						coord[x][y][2]=(_zmin+(save_3-zmin)*(_zmax-_zmin)/(zmax-zmin));
					}
					sprintf((char*)s,"Working... %d%%\0",(int)(100*((x)*numy+y)/(numy*numx)));PrintMini(1,1,s,0);Bdisp_PutDisp_DD();
						
				};
				break;				
			}//Case 1
			case 2:
			{
				numx=spitch;numy=tpitch;
			for(int x=0;x<numx;x++)
				for(int y=0;y<numy;y++)
				{//EEVPSPASHJKA
						if(IsKeyDown(KEY_CTRL_AC)) return;
					double d1,d2;d1=smin+x*sscale;d2=tmin+y*tscale;
					unsigned char s[400];
					sprintf((char*)s,"(0*(S=(s=%f)))+(0*(T=(t=%f)))+EEVPSPASHJKA(%s)\0",d1,d2,functions[functionsel]);
					save_1=save_2=save_3=0;
					int epos,ecode=!EvaluateD((char*)s,&result,&epos);
					candraw[x][y]=ecode;
					if(ecode){
						coord[x][y][0]=(_xmin+(save_1-xmin)*(_xmax-_xmin)/(xmax-xmin));
						coord[x][y][1]=(_ymin+(save_2-ymin)*(_ymax-_ymin)/(ymax-ymin));
						coord[x][y][2]=(_zmin+(save_3-zmin)*(_zmax-_zmin)/(zmax-zmin));
					}
					sprintf((char*)s,"Working... %d%%\0",(int)(100*((x)*numy+y)/(numy*numx)));PrintMini(1,1,s,0);Bdisp_PutDisp_DD();
				};
				break;				
			}//Case 2
			case 3:
			{
				numx=spitch;numy=tpitch;
			for(int x=0;x<numx;x++)
				for(int y=0;y<numy;y++)
				{//EEVPSPASHJKA
						if(IsKeyDown(KEY_CTRL_AC)) return;
					double d1,d2;d1=smin+x*sscale,d2=tmin+y*tscale;
					unsigned char s[400];
					sprintf((char*)s,"(0*((S=(s=%f))+(T=(t=%f))))+%s\0",d1,d2,functions[functionsel]);
					int epos,ecode=!EvaluateD((char*)s,&result,&epos);
					candraw[x][y]=ecode;
					result=(_zmin+(result-zmin)*(_zmax-_zmin)/(zmax-zmin));
					if(ecode) 
					{
						coord[x][y][0]=(_xmin+((d1*cos(d2))-xmin)*(_xmax-_xmin)/(xmax-xmin));
						coord[x][y][1]=(_ymin+((d1*sin(d2))-ymin)*(_ymax-_ymin)/(ymax-ymin));
						coord[x][y][2]=result;
					}
					sprintf((char*)s,"Working... %d%%\0",(int)(100*((x)*numy+y)/(numx*numy)));PrintMini(1,1,s,0);Bdisp_PutDisp_DD();
				};
				break;
			}//Case 3
			case 4:
			{//result*math.cos(d2)*math.cos(d1),result*math.sin(d1)*math.cos(d2),result*math.sin(d2)
				numx=spitch;numy=tpitch;
			for(int x=0;x<numx;x++)
				for(int y=0;y<numy;y++)
				{//EEVPSPASHJKA
						if(IsKeyDown(KEY_CTRL_AC)) return;
					double d1,d2;d1=smin+x*sscale,d2=tmin+y*tscale;
					unsigned char s[400];
					sprintf((char*)s,"(0*((S=(s=%f))+(T=(t=%f))))+%s\0",d1,d2,functions[functionsel]);
					int epos,ecode=!EvaluateD((char*)s,&result,&epos);
					candraw[x][y]=ecode;
					if(ecode) 
					{
						coord[x][y][0]=(_xmin+((result*cos(d2)*cos(d1))-xmin)*(_xmax-_xmin)/(xmax-xmin));
						coord[x][y][1]=(_ymin+((result*sin(d1)*cos(d2))-ymin)*(_ymax-_ymin)/(ymax-ymin));
						coord[x][y][2]=(_zmin+(result*sin(d2)-zmin)*(_zmax-_zmin)/(zmax-zmin));
					}
					sprintf((char*)s,"Working... %d%%\0",(int)(100*((x)*numy+y)/(numx*numy)));PrintMini(1,1,s,0);Bdisp_PutDisp_DD();
				};
				break;
			}//Case 4
		}
		//fix the lines
			while(1){
			sin_table_th_=128.*sin(th);sin_table_ph_=128.*sin(ph);
			cos_table_th_=128.*cos(th);cos_table_ph_=128.*cos(ph);
			//DRAW GRAPH!!!!!
			Bdisp_AllClr_VRAM();
			for(int x=0;x<numx;x++)
				for(int y=0;y<numy-1;y++)
					if(candraw[x][y]&&candraw[x][y+1])DrawLine(coord[x][y][0],coord[x][y][1],coord[x][y][2],coord[x][y+1][0],coord[x][y+1][1],coord[x][y+1][2]);
			for(int y=0;y<numy;y++)
				for(int x=0;x<numx-1;x++)
					if(candraw[x][y]&&candraw[x+1][y])DrawLine(coord[x][y][0],coord[x][y][1],coord[x][y][2],coord[x+1][y][0],coord[x+1][y][1],coord[x+1][y][2]);
			switch(axs)
			{
				case 1:
					DrawLine(_xmin,0,0,_xmax,0,0);DrawLine(0,_ymin,0,0,_ymax,0);DrawLine(0,0,_zmin,0,0,_zmax);
					PrintMini(vx(xc(_xmax,0,0)),vy(yc(_xmax,0,0)),"x",0);
					PrintMini(vx(xc(0,_ymax,0)),vy(yc(0,_ymax,0)),"y",0);
					PrintMini(vx(xc(0,0,_zmax)),vy(yc(0,0,_zmax)),"z",0);
				break;
				case 2:
					DrawLine(_xmin,_ymin,_zmin,_xmin,_ymax,_zmin);
					DrawLine(_xmin,_ymin,_zmin,_xmax,_ymin,_zmin);
					DrawLine(_xmax,_ymin,_zmin,_xmax,_ymax,_zmin);
					DrawLine(_xmax,_ymax,_zmin,_xmin,_ymax,_zmin);
					DrawLine(_xmin,_ymin,_zmax,_xmin,_ymax,_zmax);
					DrawLine(_xmin,_ymin,_zmax,_xmax,_ymin,_zmax);
					DrawLine(_xmax,_ymin,_zmax,_xmax,_ymax,_zmax);
					DrawLine(_xmax,_ymax,_zmax,_xmin,_ymax,_zmax);
					DrawLine(_xmin,_ymin,_zmin,_xmin,_ymin,_zmax);
					DrawLine(_xmin,_ymax,_zmin,_xmin,_ymax,_zmax);
					DrawLine(_xmax,_ymin,_zmin,_xmax,_ymin,_zmax);
					DrawLine(_xmax,_ymax,_zmin,_xmax,_ymax,_zmax);
				break;
			}
			//Bdisp_AreaReverseVRAM(0,0,127,63);
			while(1) {
				unsigned int key;GetKey(&key);
				switch(key)
				{
					case KEY_CTRL_UP: ph+=atan(1.)/5.;ph=ct(ph,8.*atan(1.));break;
					case KEY_CTRL_DOWN: ph-=atan(1.)/5.;ph=ct(ph,8.*atan(1.));break;
					case KEY_CTRL_LEFT: th+=atan(1.)/5.;th=ct(th,8.*atan(1.));break;
					case KEY_CTRL_RIGHT: th-=atan(1.)/5.;th=ct(th,8.*atan(1.));break;
					case KEY_CHAR_PLUS:
						result=(winx1+winx2)/2;winx1=result-(result-winx1)/1.05;winx2=result-(result-winx2)/1.05;
						result=(winy1+winy2)/2;winy1=result-(result-winy1)/1.05;winy2=result-(result-winy2)/1.05;
						break;
					case KEY_CHAR_MINUS:
						result=(winx1+winx2)/2;winx1=result-(result-winx1)*1.05;winx2=result-(result-winx2)*1.05;
						result=(winy1+winy2)/2;winy1=result-(result-winy1)*1.05;winy2=result-(result-winy2)*1.05;
						break;
					case KEY_CTRL_F1:axs++;axs%=3;break;
					case KEY_CTRL_EXIT:Bkey_Set_RepeatTime_Default();return;
					default: continue;
				}
				break;
			}
			}
		}
};